<?php

/**
 *  README for sample service
 *
 *  This generated sample service contains functions that illustrate typical service operations.
 *  Use these functions as a starting point for creating your own service implementation. Modify the 
 *  function signatures, references to the database, and implementation according to your needs. 
 *  Delete the functions that you do not use.
 *
 *  Save your changes and return to Flash Builder. In Flash Builder Data/Services View, refresh 
 *  the service. Then drag service operations onto user interface components in Design View. For 
 *  example, drag the getAllItems() operation onto a DataGrid.
 *  
 *  This code is for prototyping only.
 *  
 *  Authenticate the user prior to allowing them to call these methods. You can find more 
 *  information at http://www.adobe.com/go/flex_security
 *
 */
class DatcomercialService {

	var $username = "root";
	var $password = "root";
	var $server = "localhost";
	var $port = "3306";
	var $databasename = "dbinelastic";
	var $tablename = "datcomercial";

	var $connection;

	/**
	 * The constructor initializes the connection to database. Everytime a request is 
	 * received by Zend AMF, an instance of the service class is created and then the
	 * requested method is invoked.
	 */
	public function __construct() {
	  	$this->connection = mysqli_connect(
	  							$this->server,  
	  							$this->username,  
	  							$this->password, 
	  							$this->databasename,
	  							$this->port
	  						);

		$this->throwExceptionOnError($this->connection);
	}
/**
	 * Returns all the rows from the table.
	 *
	 * Add authroization or any logical checks for secure access to your data 
	 *
	 * @return array
	 */
	public function getAllDatcomercial() {
	
		$stmt = mysqli_prepare($this->connection, "CALL getAllDatcomercial");		
		$this->throwExceptionOnError();
		
		mysqli_stmt_execute($stmt);
		$this->throwExceptionOnError();
		
		$rows = array();
		$row = new stdClass();
		
		mysqli_stmt_bind_result($stmt, $row->idarticulo, $row->ancho, $row->peso, $row->comp1, $row->desc_comp1, $row->comp2, $row->desc_comp2, $row->comp3, $row->desc_comp3, $row->comp4, $row->desc_comp4);
		
	    while (mysqli_stmt_fetch($stmt)) {
	      $rows[] = $row;
	      $row = new stdClass();
	      mysqli_stmt_bind_result($stmt, $row->idarticulo, $row->ancho, $row->peso, $row->comp1, $row->desc_comp1, $row->comp2, $row->desc_comp2, $row->comp3, $row->desc_comp3, $row->comp4, $row->desc_comp4);
	    }
		
		mysqli_stmt_free_result($stmt);
	    mysqli_close($this->connection);
	
	    return $rows;
	}
	/**
	 * Returns the item corresponding to the value specified for the primary key.
	 *
	 * Add authorization or any logical checks for secure access to your data 
	 *
	 * 
	 * @return stdClass
	 */
	public function getDatcomercialByID($itemID) {
		
				$stmt = mysqli_prepare($this->connection, "SELECT * FROM $this->tablename where idarticulo LIKE '%$itemID%'");	
		$this->throwExceptionOnError();
		
		mysqli_stmt_execute($stmt);
		$this->throwExceptionOnError();
		
		$rows = array();
		$row = new stdClass();
		
		mysqli_stmt_bind_result($stmt, $row->idarticulo, $row->ancho, $row->peso, $row->comp1, $row->desc_comp1, $row->comp2, $row->desc_comp2, $row->comp3, $row->desc_comp3, $row->comp4, $row->desc_comp4);
		
		while (mysqli_stmt_fetch($stmt)) {
	      $rows[] = $row;
	      $row = new stdClass();
	     mysqli_stmt_bind_result($stmt, $row->idarticulo, $row->ancho, $row->peso, $row->comp1, $row->desc_comp1, $row->comp2, $row->desc_comp2, $row->comp3, $row->desc_comp3, $row->comp4, $row->desc_comp4);
	    }
		
		mysqli_stmt_free_result($stmt);
	    mysqli_close($this->connection);
	
	    return $rows;
	}

	/**
	 * Returns the item corresponding to the value specified for the primary key.
	 *
	 * Add authorization or any logical checks for secure access to your data 
	 *
	 * 
	 * @return stdClass
	 */
	public function createDatcomercial($item) {

		$stmt = mysqli_prepare($this->connection, "INSERT INTO $this->tablename (idarticulo, ancho, peso, comp1, desc_comp1, comp2, desc_comp2, comp3, desc_comp3, comp4, desc_comp4) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
		$this->throwExceptionOnError();

		mysqli_stmt_bind_param($stmt, 'siiisisisis', $item->idarticulo, $item->ancho, $item->peso, $item->comp1, $item->desc_comp1, $item->comp2, $item->desc_comp2, $item->comp3, $item->desc_comp3, $item->comp4, $item->desc_comp4);
		$this->throwExceptionOnError();

		mysqli_stmt_execute($stmt);		
		$this->throwExceptionOnError();

		$autoid = $item->idarticulo;

		mysqli_stmt_free_result($stmt);		
		mysqli_close($this->connection);

		return $autoid;
	}

	/**
	 * Updates the passed item in the table.
	 *
	 * Add authorization or any logical checks for secure access to your data 
	 *
	 * @param stdClass $item
	 * @return void
	 */
	public function updateDatcomercial($item) {
	
		$stmt = mysqli_prepare($this->connection, "UPDATE $this->tablename SET ancho=?, peso=?, comp1=?, desc_comp1=?, comp2=?, desc_comp2=?, comp3=?, desc_comp3=?, comp4=?, desc_comp4=? WHERE idarticulo=?");		
		$this->throwExceptionOnError();
		
		mysqli_stmt_bind_param($stmt, 'iiisisisiss', $item->ancho, $item->peso, $item->comp1, $item->desc_comp1, $item->comp2, $item->desc_comp2, $item->comp3, $item->desc_comp3, $item->comp4, $item->desc_comp4, $item->idarticulo);		
		$this->throwExceptionOnError();

		mysqli_stmt_execute($stmt);		
		$this->throwExceptionOnError();
		
		mysqli_stmt_free_result($stmt);		
		mysqli_close($this->connection);
	}

	/**
	 * Deletes the item corresponding to the passed primary key value from 
	 * the table.
	 *
	 * Add authorization or any logical checks for secure access to your data 
	 *
	 * 
	 * @return void
	 */
	public function deleteDatcomercial($itemID) {
				
		$stmt = mysqli_prepare($this->connection, "DELETE FROM $this->tablename WHERE idarticulo = ?");
		$this->throwExceptionOnError();
		
		mysqli_stmt_bind_param($stmt, 's', $itemID);
		mysqli_stmt_execute($stmt);
		$this->throwExceptionOnError();
		
		mysqli_stmt_free_result($stmt);		
		mysqli_close($this->connection);
	}


	/**
	 * Returns the number of rows in the table.
	 *
	 * Add authorization or any logical checks for secure access to your data 
	 *
	 * 
	 */
	public function count() {
		$stmt = mysqli_prepare($this->connection, "SELECT COUNT(*) AS COUNT FROM $this->tablename");
		$this->throwExceptionOnError();

		mysqli_stmt_execute($stmt);
		$this->throwExceptionOnError();
		
		mysqli_stmt_bind_result($stmt, $rec_count);
		$this->throwExceptionOnError();
		
		mysqli_stmt_fetch($stmt);
		$this->throwExceptionOnError();
		
		mysqli_stmt_free_result($stmt);
		mysqli_close($this->connection);
		
		return $rec_count;
	}


	/**
	 * Returns $numItems rows starting from the $startIndex row from the 
	 * table.
	 *
	 * Add authorization or any logical checks for secure access to your data 
	 *
	 * 
	 * 
	 * @return array
	 */
	public function getDatcomercial_paged($startIndex, $numItems) {
		
		$stmt = mysqli_prepare($this->connection, "SELECT * FROM $this->tablename LIMIT ?, ?");
		$this->throwExceptionOnError();
		
		mysqli_stmt_bind_param($stmt, 'ii', $startIndex, $numItems);
		mysqli_stmt_execute($stmt);
		$this->throwExceptionOnError();
		
		$rows = array();
		
		mysqli_stmt_bind_result($stmt, $row->idarticulo, $row->ancho, $row->peso, $row->comp1, $row->desc_comp1, $row->comp2, $row->desc_comp2, $row->comp3, $row->desc_comp3, $row->comp4, $row->desc_comp4);
		
	    while (mysqli_stmt_fetch($stmt)) {
	      $rows[] = $row;
	      $row = new stdClass();
	      mysqli_stmt_bind_result($stmt, $row->idarticulo, $row->ancho, $row->peso, $row->comp1, $row->desc_comp1, $row->comp2, $row->desc_comp2, $row->comp3, $row->desc_comp3, $row->comp4, $row->desc_comp4);
	    }
		
		mysqli_stmt_free_result($stmt);		
		mysqli_close($this->connection);
		
		return $rows;
	}
	
	
	/**
	 * Utility function to throw an exception if an error occurs 
	 * while running a mysql command.
	 */
	private function throwExceptionOnError($link = null) {
		if($link == null) {
			$link = $this->connection;
		}
		if(mysqli_error($link)) {
			$msg = mysqli_errno($link) . ": " . mysqli_error($link);
			throw new Exception('MySQL Error - '. $msg);
		}		
	}
}

?>
